//Libraries
#include <SD.h>//https://www.arduino.cc/en/reference/SD
#include <Adafruit_GFX.h>//https://github.com/adafruit/Adafruit-GFX-Library
#include <MCUFRIEND_kbv.h>//https://github.com/prenticedavid/MCUFRIEND_kbv
#include <TouchScreen.h> //https://github.com/adafruit/Adafruit_TouchScreen
#include <Wire.h>

//Constants - TFT Screen parameters
#define SD_CS 10
#define BLACK 0
#define GREY 21845
#define BLUE 31
#define RED 63488
#define GREEN 2016
#define DARKGREEN 1472
#define CYAN 2047
#define MAGENTA 63519
#define YELLOW 65504
#define GOLD 56768
#define WHITE 65535

//Touch screen configuration
#define MINPRESSURE 200
#define MAXPRESSURE 1000
// ALL Touch panels and wiring is DIFFERENT
// copy-paste results from TouchScreen_Calibr_native.ino
//3.5 Parameters
const int XP = 8, XM = A2, YP = A3, YM = 9; //320x480 ID=0x9486
const int TS_LEFT = 144, TS_RT = 887, TS_TOP = 936, TS_BOT = 87;
//2.8 Parameters
//const int XP = 8, XM = A2, YP = A3, YM = 9; //240x320 ID=0x9341
//const int TS_LEFT = 907, TS_RT = 120, TS_TOP = 74, TS_BOT = 913;
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
TSPoint p;
bool down;
int pixel_x, pixel_y;     //Touch_getXY() updates global vars
//Variables
int currentPage  = 0, oldPage = -1;
//Objects
MCUFRIEND_kbv tft;
// Button calibration
Adafruit_GFX_Button page1_btn, page2_btn;
int margin = 5;
int btnWidth = 100;
int btnHeight = 40;
int btnY = 200;

int Iter = 0;
int iter2=0;
int iter3=0;
int n = 0;
int Weight=1494;


void setup() {
 //Init Serial USB
 Serial.begin(9600);
 Serial.println(F("Initialize System"));
 //Init tft screen
 uint16_t ID = tft.readID();
 if (ID == 0xD3D3) ID = 0x9486;  //for 3.5" TFT LCD Shield , 0x9341 for 2.8" TFT LCD Shield  
 tft.begin(ID);
 tft.setRotation(1);//0-PORTRAIT 1-PAYSAGE 2-REVERSE PORTRAIT 3-REVERSE PAYSAGE
 //Uncomment if you are using SD
 /*if (!SD.begin(SD_CS)) {
    Serial.println(F("initialization failed!"));
    return;
  }*/
 currentPage = 0; // Indicates that we are at Home Screen


# define I2C_SLAVE_ADDRESS 20
#define PAYLOAD_SIZE 2

Wire.begin(20);
Serial.begin(9600);
// Temps d'initialisation du systeme ecran
delay(2000);


}

// MAIN BODY


void loop(){

if (iter2==0)
  {
  // Display presentation screen only along the first connection
  drawPageINI();
  delay(2000);
  iter2=iter2+1;
  }


Wire.onReceive(receiveEvents);
delay(1000);
}


void receiveEvents(int numBytes)
{
//int n = 0;
//int Weight;
n = Wire.read();
Serial.println(numBytes);
Serial.println(F("Info reçue"));
Serial.print(F("received value : "));
Weight=6*n;
Serial.println(Weight);
delay(2000);


 if (Weight == 0) {
    Serial.println("BOUCLE Weight =0"); Serial.print(Weight);
    delay(1000);
    drawPage05();
    delay(1000);
    drawPage0();
    delay(1000);
    //Screen();
    // No abnormal move
    Serial.println("Alarm ON No Movement");
    // Code Weight 0 equals to 0 in Master Program = No Movement

  } else if (Weight == 942) {
    Serial.println("BOUCLE Weight =942"); Serial.println(Weight);
    delay(1000);
    drawPage05();
    delay(1000);
    drawPage01();
    delay(1000);
    //Screen();
    //Slight movement must be pets
    Serial.println("Slight movement must be pets");
    Weight=0;
    // Code Weight 942 equals to 157 in Master Program = Movements thought to be connected with Pets movement
        
  } else if (Weight == 306) {
    Serial.println("BOUCLE Weight =306"); Serial.print(Weight);
    delay(1000);
    drawPage05();
    delay(1000);
    drawPage1();
    delay(2000);
    //Screen();
    // Risk of Intrusion
    Serial.println("Risk of Intrusion");
    // Code Weight 306 equals to 307 in Master Program = Excess of Weight & US Sensor detection - after 2 detections in a row

  } else if (Weight == 570) {
    Serial.println("BOUCLE Weight =570"); Serial.print(Weight);
    delay(1000);
    drawPage05();
    delay(1000);
    drawPage11();
    delay(1000);
    //Screen();
    // Risk of Intrusion
    Serial.println("Intrusion");
    // Code Weight 570 equals to 607 in Master Program = High Excess of Weight measured by Sensor - triggers immediate Alarm
     
  } else if (Weight == 1494) {
    Serial.println("BOUCLE Weight =1494"); Serial.print(Weight);
    // 1494 est la valeur qui est lue sur la carte slave apres avoir fait passé par l'I2C depuis la carte Master la valeur de 607
    //Iter=Weight;
    drawPage04();
    //Iter=0;
    Serial.println("ALARM OFF");
    delay(2000);
    //Screen(); 
    // Code Weight 1494 equals to 249 in Master Program = Alarm Deactivatiion 

  }
}






void Screen() {
 down = Touch_getXY();
 switch (currentPage) {
   case 0:
     if (currentPage != oldPage) {
       Serial.println(F("ALARM IS ON  - NO ISSUE"));
       drawPage06();
     }
     page2_btn.press(down && page2_btn.contains(pixel_x, pixel_y));
     //if (page2_btn.justReleased()) page2_btn.drawButton();
     if (page2_btn.justPressed()) {
       currentPage = 1;
     }
     break;
   case 1:
     if (currentPage != oldPage) {
       Serial.println(F("Page 2"));
       drawPage2();
     }
     page1_btn.press(down && page1_btn.contains(pixel_x, pixel_y));
     //if (page1_btn.justReleased()) page1_btn.drawButton();
     if (page1_btn.justPressed()) {
       currentPage = 0;
     }
     break;
 }
}
// PAGE WITH NORMAL ACTIVITIES - NOTHING DETECTED

void drawPage0() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(BLUE, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(30,50); 
 tft.print("Mrs & Mr HAROLD - APT.");
 tft.setCursor(40,80); 
 tft.setTextColor(GREEN, WHITE);
 tft.print(" SECURITY STATUS OK "); 
 tft.setCursor(30,160); 
 tft.print(" NO ABNORMAL ACTIVITY "); 
 
 oldPage = currentPage;
}




void drawPage1() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(RED, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(20,50); 
 tft.print(" VISIT Mrs & Mr HAROLD");
 tft.setCursor(40,160); 
 tft.setTextColor(WHITE, GOLD);
 tft.print(" RISK OF INTRUSION "); 
 //Button
 //page2_btn.initButton(&tft, tft.width() / 2., 200, 3 * btnWidth, btnHeight, WHITE, GREEN, WHITE, "COMPLETE", 2);
 //page2_btn.drawButton(true);

 //page2_btn.drawButton(false);
 
 //oldPage = currentPage;
}

void drawPage11() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(RED, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(20,50); 
 tft.print(" VISIT Mrs & Mr HAROLD");
 tft.setCursor(40,160); 
 tft.setTextColor(WHITE, RED);
 tft.print(" INTRUSION - CHECK NOW "); 
 //Button
 //page2_btn.initButton(&tft, tft.width() / 2., 200, 3 * btnWidth, btnHeight, WHITE, GREEN, WHITE, "COMPLETE", 2);
 //page2_btn.drawButton(true);

 //page2_btn.drawButton(false);
 
 //oldPage = currentPage;
}

void drawPage01() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(BLUE, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(30,50); 
 tft.print("Mrs & Mr HAROLD - APT.");
 tft.setCursor(40,80); 
 tft.print(" SECURITY STATUS OK "); 

 tft.setCursor(20,160); 
 tft.setTextColor(WHITE, YELLOW);
 tft.print(" POTENTIAL PETS MOVEMENT "); 
 
 //oldPage = currentPage;
}


void drawPage04() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(BLUE, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(30,50); 
 tft.print("Mrs & Mr HAROLD - APT.");
 tft.setCursor(80,80); 
 tft.print(" ALARM STATUS "); 
 
 tft.setCursor(50,160); 
 tft.setTextColor(WHITE, BLUE);
 tft.print("--- SYSTEM OFF ---"); 
 
 //oldPage = currentPage;
}

void drawPage05() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(BLUE, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(30,50); 
 tft.print("Mrs & Mr HAROLD - APT.");
 tft.setCursor(80,80); 
 tft.print(" ALARM STATUS "); 
 
 tft.setCursor(50,160); 
 tft.setTextColor(WHITE, GREEN);
 tft.print("--- SYSTEM ON ---"); 
 
 //oldPage = currentPage;
}


void drawPage06() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(WHITE);
 //Title
 tft.setCursor(5, 10);
 tft.setTextSize(2);
 tft.setTextColor(GREEN, WHITE);
 tft.print("SECURITY SERVICE"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(BLUE, WHITE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(30,50); 
 tft.print("Mrs & Mr HAROLD - APT.");
 tft.setCursor(80,80); 
 tft.print(" ALARM STATUS "); 
 
 tft.setCursor(50,160); 
 tft.setTextColor(RED, WHITE);
 tft.print("--- NO ISSUE ---"); 
 
 //oldPage = currentPage;
}

void drawPageINI() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(BLUE);
 //Title
 tft.setCursor(10, 10);
 tft.setTextSize(3);
 tft.setTextColor(RED, BLUE);
 tft.print("ESME SUDRIA"); // Prints the string on the screen
 tft.drawLine(0, 64, 319, 32, BLUE); // Draws the red line
 //text
 tft.setTextSize(2);
 tft.setTextColor(WHITE, BLUE);
// tft.setCursor(tft.width() / 2. -  14 * 3 * 3, 80);
 tft.setCursor(40,70); 
 tft.print("Blind Pass");
 tft.setCursor(30,110); 
 tft.print(" ~~ Security Add-on ~~ "); 
 
 tft.setCursor(50,210); 
 tft.setTextColor(WHITE, BLUE);
 tft.setTextSize(1);
 tft.print("                       Ingrid STERLE  2022"); // Prints the string on the screen

 //delay(5000);
 //drawPage04();
 iter3=1;
 //tft.reset();

 oldPage = currentPage;
}



void drawPage2() { /* function drawHomePage */
 tft.setRotation(1);
 tft.fillScreen(GREY);
 //Title
 tft.setCursor(0, 10);
 tft.setTextSize(3);
 tft.setTextColor(WHITE, GREY);
 tft.print("This is page 2"); // Prints the string on the screen
 tft.drawLine(0, 32, 319, 32, DARKGREEN); // Draws the red line
 //text
 tft.setTextSize(3);
 tft.setTextColor(GREEN, BLACK);
 tft.setCursor(tft.width() / 2. - 14 * 3 * 3, 80);
 tft.print(" Go to page 1 ");
 //Button
 page1_btn.initButton(&tft, tft.width() / 2., 200, 2 * btnWidth, btnHeight, WHITE, RED, BLACK, "Page 1", 2);
 page1_btn.drawButton(false);
 
 //oldPage = currentPage;
}


/************************************************************************************
    UTILITY FUNCTION
*************************************************************************************/



bool Touch_getXY(void)
{
 p = ts.getPoint();
 pinMode(YP, OUTPUT);      //restore shared pins
 pinMode(XM, OUTPUT);
 digitalWrite(YP, HIGH);
 digitalWrite(XM, HIGH);
 bool pressed = (p.z > MINPRESSURE && p.z < MAXPRESSURE);
 if (pressed) {
   if (tft.width() <= tft.height()) { //Portrait
     pixel_x = map(p.x, TS_LEFT, TS_RT, 0, tft.width()); //.kbv makes sense to me
     pixel_y = map(p.y, TS_TOP, TS_BOT, 0, tft.height());
   } else {
     pixel_x = map(p.y, TS_TOP, TS_BOT, 0, tft.width());
     pixel_y = map(p.x, TS_RT, TS_LEFT, 0, tft.height());
   }
 }
 return pressed;
}
